VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMCI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'----------------------------------------------------------------------------------------------------
'====================================================================================================
'= API's
'====================================================================================================
'----------------------------------------------------------------------------------------------------
Private Declare Function mciGetErrorString Lib "winmm" Alias "mciGetErrorStringA" (ByVal fdwError As Long, ByVal lpszErrorText As String, ByVal cchErrorText As Long) As Long
Private Declare Function mciSendString Lib "winmm" Alias "mciSendStringA" (ByVal lpszCommand As String, ByVal lpszReturnString As String, ByVal cchReturn As Long, ByVal hwndCallback As Long) As Long
'
Private Declare Function SetTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long) As Long
'
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
'
Private Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
Private Declare Function GetTickCount Lib "kernel32" () As Long
Private Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal hInstance As Long, ByVal lpsz As Long, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
Private Declare Function ShellAbout Lib "shell32.dll" Alias "ShellAboutA" (ByVal hWnd As Long, ByVal szApp As String, ByVal szOtherStuff As String, ByVal hIcon As Long) As Long
Private Declare Function ShellExecuteEx Lib "shell32" (lpExecInfo As SHELLEXECUTEINFO) As Long
'----------------------------------------------------------------------------------------------------
'====================================================================================================
'= Events
'====================================================================================================
'----------------------------------------------------------------------------------------------------
Public Event FileOpen()
Public Event FileClose()
'
Public Event PlaybackStart()
Public Event PlaybackPause()
Public Event PlaybackResume()
Public Event PlaybackStop()
Public Event PlaybackSpeedChange(ByVal Factor As Double)
Public Event PlaybackProgress(ByVal MilliSeconds As Long)
Public Event PlaybackSeekTo(ByVal MilliSeconds As Long)
Public Event PlaybackVolumeChange(ByVal Volume As Long)
Public Event PlaybackFileEnd(ByVal VB_NOTIFY As Long)
'
Public Event error(ByVal Number As Integer, ByVal Description As String)
'----------------------------------------------------------------------------------------------------
'====================================================================================================
'= Const
'====================================================================================================
'---------------------------------------------------------------|------------------------------------
Private Const GWL_WNDPROC               As Long = &HFFFFFFFC    ' -4
Private Const WM_TIMER                  As Long = &H113&        '
Private Const WM_LBUTTONDOWN            As Long = &H201&        '
Private Const WM_PARENTNOTIFY           As Long = &H210&        '
Private Const SEE_MASK_INVOKEIDLIST     As Long = &HC&          '
Private Const MM_MCINOTIFY              As Long = &H3B9&        '
Private Const MCI_NOTIFY_SUCCESSFUL     As Long = &H1&          ' The conditions initiating the callback function have been met.
Private Const MCI_NOTIFY_SUPERSEDED     As Long = &H2&          ' The device received another command with the "notify" flag set and the current conditions for initiating the callback function have been superseded.
Private Const MCI_NOTIFY_ABORTED        As Long = &H4&          ' The device received a command that prevented the current conditions for initiating the callback function from being met. If a new command interrupts the current command and it also requests notification, the device sends this message only and not MCI_NOTIFY_SUPERSEDED.
Private Const MCI_NOTIFY_FAILURE        As Long = &H8&          ' A device error occurred while the device was executing the command.
'|

'---------------------------------------------------------------|------------------------------------
'====================================================================================================
'= Types
'====================================================================================================
'---------------------------------------------------------------|------------------------------------
Private Type SHELLEXECUTEINFO                                   '
    cbSize                              As Long                 '
    fMask                               As Long                 '
    hWnd                                As Long                 '
    lpVerb                              As String               '
    lpFile                              As String               '
    lpParameters                        As String               '
    lpDirectory                         As String               '
    nShow                               As Long                 '
    hInstApp                            As Long                 '
    lpIDList                            As Long                 'Optional fields
    lpClass                             As String               '
    hkeyClass                           As Long                 '
    dwHotKey                            As Long                 '
    hIcon                               As Long                 '
    hProcess                            As Long                 '
End Type                                                        '
'---------------------------------------------------------------|------------------------------------
'====================================================================================================
'= Private Property Variables
'====================================================================================================
'---------------------------------------------------------------|------------------------------------
Private wpOrigWndProc                   As Long                 '
Private strAlias                        As String               '
Private lngDestinationLeft              As Long                 '
Private lngDestinationTop               As Long                 '
Private lngDestinationWidth             As Long                 '
Private lngDestinationHeight            As Long                 '
Private blnTimer                        As Boolean              '
'---------------------------------------------------------------|------------------------------------
'====================================================================================================
'= Public Property Variables
'====================================================================================================
'---------------------------------------------------------------|------------------------------------
Private objParent                       As PictureBox           '
Private strFilePath                     As String               '
Private strUrl                          As String               '
Private blnKeepAspectRatio              As Boolean              '
'---------------------------------------------------------------|------------------------------------
'====================================================================================================
'= Public Property Variables (Read Only)
'====================================================================================================
'---------------------------------------------------------------|------------------------------------
Private lngAudioBitsPerSample           As Long                 '
Private lngAudioChannels                As Long                 '
Private dblMovieFrameRate               As Double               '
Private lngMovieLength                  As Long                 '
Private lngMoviePosition                As Long                 '
Private lngMovieLeft                    As Long                 '
Private lngMovieTop                     As Long                 '
Private lngMovieWidth                   As Long                 '
Private lngMovieHeight                  As Long                 '
Private lngSpeed                        As Long                 '
Private lngVolume                       As Long                 '
Private blnIsOpened                     As Boolean              '
Private blnIsPaused                     As Boolean              '
Private blnIsPlaying                    As Boolean              '
Private blnIsFullScreen                 As Boolean              '
Private blnIsMovie                      As Boolean              '
'---------------------------------------------------------------|------------------------------------
'====================================================================================================
'= Private Properties
'====================================================================================================
'----------------------------------------------------------------------------------------------------
'-----[ Property Alias ]-----------------------------------------------------------------------------
Private Property Get Alias() As String
    Alias = strAlias
End Property
Private Property Let Alias(strNewAlias As String)
    strAlias = strNewAlias
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property DestinationLeft ]-------------------------------------------------------------------
Private Property Get DestinationLeft() As Long
    DestinationLeft = lngDestinationLeft
End Property
Private Property Let DestinationLeft(lngNewDestinationLeft As Long)
    lngDestinationLeft = lngNewDestinationLeft
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property DestinationTop ]--------------------------------------------------------------------
Private Property Get DestinationTop() As Long
    DestinationTop = lngDestinationTop
End Property
Private Property Let DestinationTop(lngNewDestinationTop As Long)
    lngDestinationTop = lngNewDestinationTop
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property DestinationWidth ]------------------------------------------------------------------
Private Property Get DestinationWidth() As Long
    DestinationWidth = lngDestinationWidth
End Property
Private Property Let DestinationWidth(lngNewDestinationWidth As Long)
    lngDestinationWidth = lngNewDestinationWidth
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property DestinationHeight ]-----------------------------------------------------------------
Private Property Get DestinationHeight() As Long
    DestinationHeight = lngDestinationHeight
End Property
Private Property Let DestinationHeight(lngNewDestinationHeight As Long)
    lngDestinationHeight = lngNewDestinationHeight
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Timer ]-----------------------------------------------------------------------------
Private Property Get Timer() As Boolean
    Timer = blnTimer
End Property
Private Property Let Timer(blnNewTimer As Boolean)
    blnTimer = blnNewTimer
End Property
'----------------------------------------------------------------------------------------------------
'====================================================================================================
'= Public Properties
'====================================================================================================
'----------------------------------------------------------------------------------------------------
'-----[ Property FilePath ]--------------------------------------------------------------------------
Public Property Get Filepath() As String
    Filepath = strFilePath
End Property
Public Property Let Filepath(strNewFilePath As String)
    strFilePath = strNewFilePath
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Url ]-------------------------------------------------------------------------------
Public Property Get Url() As String
    Url = strUrl
End Property
Public Property Let Url(strNewUrl As String)
    strUrl = strNewUrl
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Parent ]----------------------------------------------------------------------------
Public Property Get Parent() As PictureBox
    Set Parent = objParent
End Property
Public Property Let Parent(objNewParent As PictureBox)
    Set objParent = objNewParent
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property KeepAspectRatio ]-------------------------------------------------------------------
Public Property Get KeepAspectRatio() As Boolean
    KeepAspectRatio = blnKeepAspectRatio
End Property
Public Property Let KeepAspectRatio(blnNewKeepAspectRatio As Boolean)
    blnKeepAspectRatio = blnNewKeepAspectRatio
End Property
'----------------------------------------------------------------------------------------------------
'====================================================================================================
'= Public Properties (Read Only)
'====================================================================================================
'----------------------------------------------------------------------------------------------------
'-----[ Property AudioBitsPerSample ]----------------------------------------------------------------
Public Property Get AudioBitsPerSample() As Long
    AudioBitsPerSample = lngAudioBitsPerSample
End Property
Private Property Let AudioBitsPerSample(lngNewAudioBitsPerSample As Long)
    lngAudioBitsPerSample = lngNewAudioBitsPerSample
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property AudioChannels ]---------------------------------------------------------------------
Public Property Get AudioChannels() As Long
    AudioChannels = lngAudioChannels
End Property
Private Property Let AudioChannels(lngNewAudioChannels As Long)
    lngAudioChannels = lngNewAudioChannels
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property MovieFrameRate ]--------------------------------------------------------------------
Public Property Get MovieFrameRate() As Double
    MovieFrameRate = dblMovieFrameRate
End Property
Private Property Let MovieFrameRate(dblNewMovieFrameRate As Double)
    dblMovieFrameRate = dblNewMovieFrameRate
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property MovieLength ]-----------------------------------------------------------------------
Public Property Get MovieLength() As Long
    MovieLength = lngMovieLength
End Property
Private Property Let MovieLength(lngNewMovieLength As Long)
    lngMovieLength = lngNewMovieLength
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property MoviePosition ]---------------------------------------------------------------------
Public Property Get MoviePosition() As Long
    MoviePosition = lngMoviePosition
End Property
Private Property Let MoviePosition(lngNewMoviePosition As Long)
    lngMoviePosition = lngNewMoviePosition
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property MovieLeft ]-------------------------------------------------------------------------
Public Property Get MovieLeft() As Long
    MovieLeft = lngMovieLeft
End Property
Private Property Let MovieLeft(lngNewMovieLeft As Long)
    lngMovieLeft = lngNewMovieLeft
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property MovieTop ]--------------------------------------------------------------------------
Public Property Get MovieTop() As Long
    MovieTop = lngMovieTop
End Property
Private Property Let MovieTop(lngNewMovieTop As Long)
    lngMovieTop = lngNewMovieTop
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property MovieWidth ]------------------------------------------------------------------------
Public Property Get MovieWidth() As Long
    MovieWidth = lngMovieWidth
End Property
Private Property Let MovieWidth(lngNewMovieWidth As Long)
    lngMovieWidth = lngNewMovieWidth
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property MovieHeight ]-----------------------------------------------------------------------
Public Property Get MovieHeight() As Long
    MovieHeight = lngMovieHeight
End Property
Private Property Let MovieHeight(lngNewMovieHeight As Long)
    lngMovieHeight = lngNewMovieHeight
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Speed ]-----------------------------------------------------------------------------
Public Property Get Speed() As Long
    Speed = lngSpeed
End Property
Private Property Let Speed(lngNewSpeed As Long)
    lngSpeed = lngNewSpeed
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property Volume ]----------------------------------------------------------------------------
Public Property Get Volume() As Long
    Volume = lngVolume
End Property
Private Property Let Volume(lngNewVolume As Long)
    lngVolume = lngNewVolume
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property IsOpened ]--------------------------------------------------------------------------
Public Property Get IsOpened() As Boolean
    IsOpened = blnIsOpened
End Property
Private Property Let IsOpened(blnNewIsOpened As Boolean)
    blnIsOpened = blnNewIsOpened
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property IsPaused ]--------------------------------------------------------------------------
Public Property Get IsPaused() As Boolean
    IsPaused = blnIsPaused
End Property
Private Property Let IsPaused(blnNewIsPaused As Boolean)
    blnIsPaused = blnNewIsPaused
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property IsPlaying ]-------------------------------------------------------------------------
Public Property Get IsPlaying() As Boolean
    IsPlaying = blnIsPlaying
End Property
Private Property Let IsPlaying(blnNewIsPlaying As Boolean)
    blnIsPlaying = blnNewIsPlaying
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property IsFullScreen ]----------------------------------------------------------------------
Public Property Get IsFullScreen() As Boolean
    IsFullScreen = blnIsFullScreen
End Property
Private Property Let IsFullScreen(blnNewIsFullScreen As Boolean)
    blnIsFullScreen = blnNewIsFullScreen
End Property
'----------------------------------------------------------------------------------------------------
'-----[ Property IsMovie ]---------------------------------------------------------------------------
Public Property Get IsMovie() As Boolean
    IsMovie = blnIsMovie
End Property
Private Property Let IsMovie(blnNewIsMovie As Boolean)
    blnIsMovie = blnNewIsMovie
End Property
'----------------------------------------------------------------------------------------------------


'####################################################################################################
'#####[ Class ]######################################################################################
'####################################################################################################
Private Sub Class_Initialize()
    modMCI.colMCI.Add Me
    '
    Volume = 100
    KeepAspectRatio = True
End Sub

Private Sub Class_Terminate()
    Dim i As Long
    '
    If ((IsPlaying = True) Or (IsPaused = True)) Then
        mmStop
        DoEvents
    End If
    If IsOpened = True Then
        mmClose
        Filepath = vbNullString
        Url = vbNullString
    End If
    '
    For i = 1 To modMCI.colMCI.Count
        If modMCI.colMCI.Item(i) Is Me Then
            modMCI.colMCI.Remove i
            Exit For
        End If
    Next i
End Sub

'####################################################################################################
'#####[ SubClass ]###################################################################################
'####################################################################################################
Public Function Hook()
    wpOrigWndProc = SetWindowLong(Parent.hWnd, GWL_WNDPROC, AddressOf WindowProc)
End Function

Public Function UnHook()
    Call SetWindowLong(Parent.hWnd, GWL_WNDPROC, wpOrigWndProc)
End Function

'####################################################################################################
'#####[ mci ]########################################################################################
'####################################################################################################
Public Sub mmAbout(hWnd As Long)
    Dim hIcon As Long
    '
    Const IMAGE_ICON        As Long = 1
    Const LR_DEFAULTCOLOR   As Long = 0
    '
    hIcon = LoadImage(App.hInstance, 1, IMAGE_ICON, 32, 32, LR_DEFAULTCOLOR)
    '
    If hIcon = 0 Then ' previous call to LoadImage() works only with compiled .exe
        hIcon = frmMain.Icon.Handle
    End If
    '
    Call ShellAbout(hWnd, App.Title, App.Comments, hIcon)
End Sub

Public Sub mmClose()
    Dim lngReturn As Long
    '
    If IsOpened = True Then
        If IsPlaying = True Then
            mmStop
            'DoEvents
        End If
        lngReturn = mciSendString("close " & Alias, vbNullString, 0&, 0&)
        If lngReturn = 0 Then
            IsOpened = False
            Alias = vbNullString
            Set Parent.Picture = Nothing
            RaiseEvent FileClose
        Else
            RaiseError lngReturn
        End If
    End If
End Sub

Public Sub mmFullScreen()
    If IsOpened = True Then
        mmPlay MoviePosition, True
    End If
End Sub

Public Sub mmOpen(Optional OpenUrl As Boolean = False)
    Dim strBuffer As String
    Dim lngReturn As Long
    '
    Alias = "MCI_" & CStr(GetTickCount())
    '
    If OpenUrl = True Then
        strBuffer = Url
        '
        If InStr(strBuffer, " ") > 0 Then
            strBuffer = Replace(strBuffer, " ", "%20")
        End If
    Else
        strBuffer = Space$(255)
        lngReturn = GetShortPathName(Filepath, strBuffer, 255)
        '
        If lngReturn > 0 Then
            strBuffer = Left(strBuffer, lngReturn)
        Else
            RaiseEvent error(53, "Datei nicht gefunden")
            Exit Sub
        End If
    End If
    '
    lngReturn = mciSendString("open " & strBuffer & " Alias " & Alias & " Parent " & CStr(Parent.hWnd) & " Style child", vbNullString, 0&, 0&)
    '
    If lngReturn = 0 Then
        MoviePosition = 0
        Speed = 1000
        IsOpened = True
        '
        mmHasWindow
        '
        mmSetTimeFormatMS
        mmSetVolume Volume
        mmGetMovieLength
        mmSetAudio Not frmMain.mnuPlaybackVolumeMute.Checked
        
        If IsMovie = True Then
            mmGetMovieSize
            mmGetMovieFrameRate
            mmSize 0, 0, Parent.Width, Parent.Height
            mmSeekTo MoviePosition
            mmSetWindowStateShow
        Else
            mmSeekTo MoviePosition
            '
            MovieLeft = -1
            MovieTop = -1
            MovieWidth = -1
            MovieHeight = -1
            MovieFrameRate = -1
        End If
        '
        RaiseEvent FileOpen
    Else
        RaiseError lngReturn
    End If
End Sub



Public Function GetFileLength(Filepath As String) As Long
    On Error GoTo ErrorH
    Dim strBuffer As String
    Dim lngReturn As Long
    Dim tAlias As String
    Dim tLength As Long
    '
    tAlias = "MCI_" & CStr(GetTickCount())
    '
    strBuffer = Space$(255)
    lngReturn = GetShortPathName(Filepath, strBuffer, 255)
    '
    If lngReturn > 0 Then
        strBuffer = Left(strBuffer, lngReturn)
    Else
        RaiseEvent error(53, "Datei nicht gefunden")
        Exit Function
    End If
    '
    lngReturn = mciSendString("open " & strBuffer & " Alias " & tAlias & " Parent " & CStr(Parent.hWnd) & " Style child", vbNullString, 0&, 0&)
    '
    If lngReturn = 0 Then
        strBuffer = Space$(128)
        lngReturn = mciSendString("status " & tAlias & " length", strBuffer, 128&, 0&)
        If lngReturn = 0 Then
            tLength = CLng(Val(StripNull(strBuffer)))
        Else
            tLength = -1
            'RaiseError lngReturn
        End If
    Else
        'RaiseError lngReturn
    End If

    GetFileLength = tLength
    

    lngReturn = mciSendString("close " & tAlias, vbNullString, 0&, 0&)
    If lngReturn = 0 Then
        tAlias = vbNullString
    Else
        'RaiseError lngReturn
    End If
    
    Exit Function
ErrorH:
    Debug.Print "error"
End Function






Public Sub mmPause()
    Dim lngReturn As Long
    '
    If IsOpened = True Then
        lngReturn = mciSendString("pause " & Alias, vbNullString, 0&, 0&)
        '
        If lngReturn = 0 Then
            IsPlaying = False
            IsPaused = True
            RaiseEvent PlaybackPause
        Else
            RaiseError lngReturn
        End If
    End If
End Sub

Public Sub mmPlay(Optional FromPositionMS As Long = 0, Optional FullScreen As Boolean = False)
    Dim lngReturn As Long
    '
    If IsOpened = True Then
        If FromPositionMS >= MovieLength Then
            lngReturn = mciSendString("play " & Alias & " from " & CStr(0) & IIf(FullScreen, " fullscreen", vbNullString) & " notify", vbNullString, 0&, Parent.hWnd)
        Else
            lngReturn = mciSendString("play " & Alias & " from " & CStr(FromPositionMS) & IIf(FullScreen, " fullscreen", vbNullString) & " notify", vbNullString, 0&, Parent.hWnd) 'frmMain.picScreen.hWnd)   'Parent.hwnd
        End If
        '
        If lngReturn = 0 Then
            Timer_Start
            '
            IsPlaying = True
            IsPaused = False
            IsFullScreen = FullScreen
            RaiseEvent PlaybackStart
        Else
            RaiseError lngReturn
        End If
    End If
End Sub

Public Sub mmResume()
    Dim lngReturn As Long
    '
    If IsOpened = True Then
        lngReturn = mciSendString("resume " & Alias, vbNullString, 0&, 0&)
        '
        If lngReturn = 0 Then
            IsPlaying = True
            IsPaused = False
            RaiseEvent PlaybackResume
        Else
            RaiseError lngReturn
        End If
    End If
End Sub

Public Sub mmSaveFrame(Filepath As String)
'    Dim blnSuccess As Boolean
'    '
'    If IsOpened = True Then
'        If modFile.File_Exist(FilePath) = True Then
'            If modFile.File_Delete(FilePath) <> True Then
'                RaiseEvent Error(2004, "Fehler beim berschreiben der Datei! Die Datei " & _
'                                       "wird anscheinend von einem anderen Programm verwendet.")
'                Exit Sub
'            End If
'        End If
'        '
'        Parent.AutoRedraw = True
'        '
'        If mmUpdateHDC() = True Then
'            Set Parent.Picture = Parent.Image
'            '
'            blnSuccess = modBitmap.BMP_Save(FilePath, Parent.hDC, DestinationWidth, DestinationHeight, DestinationWidth, DestinationHeight)
'            '
'            If blnSuccess <> True Then
'                RaiseEvent Error(2006, "Fehler beim Speichern des Frame!")
'            End If
'            '
'            Set Parent.Picture = Nothing
'        Else
'            RaiseEvent Error(2005, "Fehler beim kopieren des Frame Buffer!" & vbCrLf & vbCrLf & _
'                                   "Du kannst es versuchen indem du ALT + PRINT auf der " & _
'                                   "Tastatur drckst, und anschlieend den inhalt der " & _
'                                   "Zwischenablage in ein Bildverarbeitungsprogramm einfgst.")
'        End If
'        '
'        Parent.AutoRedraw = False
'    End If
End Sub

Public Sub mmSeekTo(MilliSeconds As Long)
    Dim lngReturn As Long
    '
    If IsOpened = True Then
        lngReturn = mciSendString("seek " & Alias & " to " & CStr(MilliSeconds), vbNullString, 0&, 0&)
        If lngReturn = 0 Then
            MoviePosition = MilliSeconds
            RaiseEvent PlaybackSeekTo(MilliSeconds)
        Else
            RaiseError lngReturn
        End If
    End If
End Sub

Public Sub mmSetAudio(AudioOn As Boolean)
    Dim lngReturn As Long
    '
    If IsOpened = True Then
        lngReturn = mciSendString("setaudio " & Alias & " " & IIf(AudioOn, "on", "off"), vbNullString, 0&, 0&)
        If lngReturn = 0 Then
            '''
        Else
            RaiseError lngReturn
        End If
    End If
End Sub

Public Sub mmSetVolume(NewVolume As Long)
    Dim lngReturn As Long
    '
    If IsOpened = True Then
        lngReturn = mciSendString("setaudio " & Alias & " volume to " & CStr(NewVolume), vbNullString, 0&, 0&)
        If lngReturn = 0 Then
            Volume = NewVolume
            RaiseEvent PlaybackVolumeChange(Volume)
        Else
            RaiseError lngReturn
        End If
    Else
        Volume = NewVolume
        RaiseEvent PlaybackVolumeChange(Volume)
    End If
End Sub

Public Sub mmShowProperties(Optional temppath As String = "FilePath")
    Dim shi       As SHELLEXECUTEINFO
    Dim lngReturn As Long
    '
    If temppath = "FilePath" Then temppath = Filepath
    '
    With shi
        .cbSize = Len(shi)
        .lpFile = temppath
        .lpVerb = "properties"
        .fMask = SEE_MASK_INVOKEIDLIST
    End With
    '
    lngReturn = ShellExecuteEx(shi)
End Sub

Public Sub mmSize(Left As Long, Top As Long, Width As Long, Height As Long)
    Dim lngReturn   As Long
    Dim dblRatio    As Double
    Dim dblNewRatio As Double
    '
    If ((IsOpened = True) And (IsMovie = True)) Then
        If KeepAspectRatio = True Then
            dblRatio = MovieWidth / MovieHeight
            '
            If Height > 0 Then
                dblNewRatio = Width / Height
            End If
            '
            Select Case dblNewRatio
                Case Is < dblRatio
                    DestinationLeft = Left
                    DestinationTop = (Height - Int(Width / dblRatio)) / 2
                    DestinationWidth = Width
                    DestinationHeight = Int(Width / dblRatio)
                Case Is = dblRatio
                    DestinationLeft = Left
                    DestinationTop = Top
                    DestinationWidth = Width
                    DestinationHeight = Height
                Case Is > dblRatio
                    DestinationLeft = (Width - Int(Height * dblRatio)) / 2
                    DestinationTop = Top
                    DestinationWidth = Int(Height * dblRatio)
                    DestinationHeight = Height
            End Select
        Else
            DestinationLeft = Left
            DestinationTop = Top
            DestinationWidth = Width
            DestinationHeight = Height
        End If
        '
        lngReturn = mciSendString("put " & Alias & " window at " & CStr(DestinationLeft) & " " & CStr(DestinationTop) & " " & CStr(DestinationWidth) & " " & CStr(DestinationHeight), vbNullString, 0&, 0&)
        '
        If lngReturn = 0 Then
            '''
        Else
            RaiseError lngReturn
        End If
    End If
End Sub

Public Sub mmSpeedFaster()
    Dim lngReturn As Long
    '
    If IsOpened = True Then
        If Speed <= 4000 Then
            Speed = Speed * 2
            '
            lngReturn = mciSendString("set " & Alias & " speed " & CStr(Speed), vbNullString, 0&, 0&)
            '
            If lngReturn = 0 Then
                RaiseEvent PlaybackSpeedChange(CDbl(Speed) / 1000)
            Else
                Speed = Speed / 2
                RaiseError lngReturn
            End If
        End If
    End If
End Sub

Public Sub mmSpeedSlower()
    Dim lngReturn As Long
    '
    If IsOpened = True Then
        If Speed >= 250 Then
            Speed = Speed / 2
            '
            lngReturn = mciSendString("set " & Alias & " speed " & CStr(Speed), vbNullString, 0&, 0&)
            '
            If lngReturn = 0 Then
                RaiseEvent PlaybackSpeedChange(CDbl(Speed) / 1000)
            Else
                Speed = Speed * 2
                RaiseError lngReturn
            End If
        End If
    End If
End Sub

Public Sub mmStop()
    Dim lngReturn As Long
    '
    If IsOpened = True Then
        lngReturn = mciSendString("stop " & Alias, vbNullString, 0&, 0&)
        If lngReturn = 0 Then
            '''
        Else
            RaiseError lngReturn
        End If
    End If
End Sub

'####################################################################################################
'#####[ MCI (Private) ]##############################################################################
'####################################################################################################
Private Sub mmGetMovieFrameRate()
    Dim strBuffer As String
    Dim lngReturn As Long
    '
    If IsOpened = True Then
        strBuffer = Space$(128)
        lngReturn = mciSendString("status " & Alias & " frame rate", strBuffer, 128&, 0&) ' nominal
        If lngReturn = 0 Then
            MovieFrameRate = (CDbl(Val(StripNull(strBuffer))) / 1000)
        Else
            MovieFrameRate = -1
            'RaiseError lngReturn
        End If
    End If
End Sub

Private Sub mmGetPositionMS()
    Dim strBuffer As String
    Dim lngReturn As Long
    '
    If IsOpened = True Then
        strBuffer = Space$(128)
        lngReturn = mciSendString("status " & Alias & " position", strBuffer, 128&, 0&)
        If lngReturn = 0 Then
            MoviePosition = CLng(Val(StripNull(strBuffer)))
        Else
            RaiseError lngReturn
        End If
    End If
End Sub

Private Sub mmGetMovieLength()
    Dim strBuffer As String
    Dim lngReturn As Long
    '
    If IsOpened = True Then
        strBuffer = Space$(128)
        lngReturn = mciSendString("status " & Alias & " length", strBuffer, 128&, 0&)
        If lngReturn = 0 Then
            MovieLength = CLng(Val(StripNull(strBuffer)))
        Else
            MovieLength = -1
            'RaiseError lngReturn
        End If
        frmMain.lngMaxMilliSeconds = MovieLength
    End If
End Sub

Private Sub mmGetMovieSize()
    Dim strTemp() As String
    Dim strBuffer As String
    Dim lngReturn As Long
    '
    If IsOpened = True Then
        strBuffer = Space$(128)
        lngReturn = mciSendString("where " & Alias & " source", strBuffer, 128&, 0&)
        If lngReturn = 0 Then
            strTemp() = Split(StripNull(strBuffer), " ")
            If ((LBound(strTemp()) = 0) And (UBound(strTemp()) = 3)) Then
                MovieLeft = CLng(Val(strTemp(0)))
                MovieTop = CLng(Val(strTemp(1)))
                MovieWidth = CLng(Val(strTemp(2)))
                MovieHeight = CLng(Val(strTemp(3)))
            Else
                RaiseEvent error(2003, "Die Auflsung konnte nicht ermittelt werden.")
            End If
        Else
            RaiseError lngReturn
        End If
    End If
End Sub

'Private Sub mmGetVolume()
'    Dim strBuffer As String
'    Dim lngReturn As Long
'    '
'    If IsOpened = True Then
'        strBuffer = Space$(128)
'        lngReturn = mciSendString("status " & Alias & " volume", strBuffer, 128&, 0&)
'        If lngReturn = 0 Then
'            Volume = CLng(Val(StripNull(strBuffer)))
'        Else
'            RaiseError lngReturn
'        End If
'    End If
'End Sub

Private Sub mmHasWindow()
    Dim strBuffer As String
    Dim lngReturn As Long
    '
    If IsOpened = True Then
        strBuffer = Space$(128)
        lngReturn = mciSendString("status " & Alias & " window handle", strBuffer, 128&, 0&)
        '
        If lngReturn = 0 Then
            IsMovie = CBool(Val(StripNull(strBuffer)))
        Else
            IsMovie = False
        End If
    End If
End Sub

Private Sub mmSetTimeFormatMS()
    Dim lngReturn As Long
    '
    If IsOpened = True Then
        lngReturn = mciSendString("set " & Alias & " time format milliseconds", vbNullString, 0&, 0&)
        If lngReturn = 0 Then
            '''
        Else
            RaiseError lngReturn
        End If
    End If
End Sub

Private Sub mmSetWindowStateShow()
    Dim lngReturn As Long
    '
    If IsOpened = True Then
        lngReturn = mciSendString("window " & Alias & " state show", vbNullString, 0&, 0&)
        If lngReturn = 0 Then
            '''
        Else
            RaiseError lngReturn
        End If
    End If
End Sub

Private Function mmUpdateHDC() As Boolean
    Dim lngReturn As Long
    '
    If IsOpened = True Then
        lngReturn = mciSendString("update " & Alias & " hdc " & CStr(Parent.hDC), vbNullString, 0&, 0&)
        If lngReturn = 0 Then
            mmUpdateHDC = True
        Else
            mmUpdateHDC = False
        End If
    End If
End Function

'####################################################################################################
'#####[ Callback ]###################################################################################
'####################################################################################################
Public Function IncommingMessage(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Select Case uMsg
        Case MM_MCINOTIFY
            Timer_Stop
            '
            IsPlaying = False
            IsPaused = False
            '
            RaiseEvent PlaybackStop
            '
            Select Case wParam
                Case MCI_NOTIFY_ABORTED
                    'RaiseEvent PlaybackFileEnd(vbAbort)    'Event beim Stoppen der Wiedergabe
                Case MCI_NOTIFY_FAILURE
                    RaiseEvent PlaybackFileEnd(vbError)
                    RaiseEvent error(2001, "Befehl konnte nicht ausgefhrt werden (MCI_NOTIFY_FAILURE).")
                Case MCI_NOTIFY_SUCCESSFUL
                    RaiseEvent PlaybackFileEnd(vbOK)
                    'mmSeekTo 0
                    
                Case MCI_NOTIFY_SUPERSEDED
                    RaiseEvent error(2002, "Befehl wurde durch einen anderen Befehl auer Kraft gesetzt (MCI_NOTIFY_SUPERSEDED).")
            End Select
            '
            IncommingMessage = 0
        Case WM_TIMER
            mmGetPositionMS
            '
            If IsPlaying = True Then
                RaiseEvent PlaybackProgress(MoviePosition)
            End If
            '
            IncommingMessage = 0
        Case WM_PARENTNOTIFY
            Dim fwEvent As Long
            '
            fwEvent = (wParam And &HFFFF&)
            '
            Select Case fwEvent
                Case WM_LBUTTONDOWN
                    If ((IsPlaying = False) And (IsPaused = False)) Then
                        mmPlay MoviePosition
                    ElseIf IsPlaying = True Then
                        mmPause
                    ElseIf IsPaused = True Then
                        mmResume
                    End If
                    '
                    IncommingMessage = 0
                Case Else
                    IncommingMessage = CallWindowProc(wpOrigWndProc, hWnd, uMsg, wParam, lParam)
            End Select
        Case Else
            IncommingMessage = CallWindowProc(wpOrigWndProc, hWnd, uMsg, wParam, lParam)
    End Select
End Function

'####################################################################################################
'#####[ Helper ]#####################################################################################
'####################################################################################################
Private Sub RaiseError(error As Long)
    Dim strBuffer As String
    '
    strBuffer = Space$(128)
    Call mciGetErrorString(error, strBuffer, 128)
    RaiseEvent error(error, StripNull(strBuffer))
End Sub

Private Function StripNull(Data As String) As String
    Dim strReturn As String
    Dim lngPos    As Long
    '
    lngPos = InStr(Data, vbNullChar)
    '
    If lngPos > 0 Then
        strReturn = Left(Data, lngPos - 1)
    Else
        strReturn = Data
    End If
    '
    StripNull = strReturn
End Function

Private Sub Timer_Start()
    Dim lngReturn As Long
    '
    If Timer = False Then
        lngReturn = SetTimer(Parent.hWnd, 1&, 100&, 0&)
        '
        Timer = (lngReturn <> 0)
    End If
End Sub

Private Sub Timer_Stop()
    Dim lngReturn As Long
    '
    If Timer = True Then
        lngReturn = KillTimer(Parent.hWnd, 1&)
        '
        Timer = Not CBool(lngReturn <> 0)
    End If
End Sub




